"""
"""
from PIL import Image
import numpy 

class imageToPixelClass:

    def __init__(self,inpSize):
        self.inpSize = inpSize

    def test(self):
        print "iTPC"

    def getPixelsFromFile(self,imageFileName):
        try: 
            im = Image.open(imageFileName)  
        except:
            print "fail to open image getPixelsClass"

        im = im.crop((0,0,300,300))

        #shrink it 
        size = (self.inpSize,self.inpSize)
        im.thumbnail(size)

        #get the pixels
        pixels = im.load()

        ##convert rgb to grey scale
        inputMatrix = numpy.zeros((self.inpSize,self.inpSize))
        for inpRow in range (0,self.inpSize):
            for inpCol in range (0,self.inpSize):
                rgb = pixels[inpCol,inpRow]
                for i in range (0,3):
                    inputMatrix[inpCol,inpRow] += rgb[i]
                    inputMatrix[inpCol,inpRow]/=3
                    
        ##set result image array
        resultImage = numpy.zeros((self.inpSize,self.inpSize))
        THRESHOLD = 50
        resultImageArray = [] 
        for outRow in range (0,self.inpSize):
            for outColumn in range (0,self.inpSize):
                if inputMatrix[outColumn,outRow] < THRESHOLD :
                    #print outRow, outColumn
                    pixelOn = (outRow*self.inpSize)+outColumn
                    resultImageArray = resultImageArray + [pixelOn]

        
        resultHexArray = []
        for intResult in resultImageArray:
            if (intResult < 256):
                visInputPrefix='0x000018'
            elif (intResult < 512):
                visInputPrefix='0x000019'
                intResult -= 256
            elif (intResult < 768):
                visInputPrefix='0x00001A'
                intResult -= 512
            elif (intResult < 1024):
                visInputPrefix='0x00001B'
                intResult -= 768
            elif (intResult < 1280):
                visInputPrefix='0x00001C'
                intResult -= 1024
            elif (intResult < 1536):
                visInputPrefix='0x00001D'
                intResult -= 1280
            elif (intResult < 1792):
                visInputPrefix='0x00001E'
                intResult -= 1536
            elif (intResult < 2048):
                visInputPrefix='0x00001F'
                intResult -= 1792
            elif (intResult < 2304):
                #undone it's not clear this works 11/12/14
                visInputPrefix='0x000020'
                intResult -= 2048
            elif (intResult < 2569):
                visInputPrefix='0x000021'
                intResult -= 2304
            else:
                print "getPixels overflow"
                
            hexResult = "%0.2X"%intResult
            hexEl = visInputPrefix+hexResult
            hexIntEl = int(hexEl,16)
            resultHexArray = resultHexArray+[hexIntEl]

        #print resultHexArray

        #return  [0x00001800, 0x00001802] 
        return resultHexArray

